// Much of this stuff shamelessly stolen from Marco Nelissen's port
// of the "Rock" screen saver.
//
//	$Log: Samhain.cpp,v $
//	Revision 1.1  1999/01/10 09:54:36  jjk
//	Initial revision
//

#include <cstdlib>
#include <Bitmap.h>
#include <Font.h>
#include <OS.h>
#include <Point.h>
#include <Rect.h>
#include <StringView.h>
#include <TextView.h>
#include <View.h>
#include <Window.h>

#include "KnotThread.h"
#include "Samhain.h"

KnotThread	*gpSaverThread = 0;
KnotThread	*gpConfigThread = 0;

// Screen saver interface.

void
module_initialize(void * /*inSettings*/, long /*inSettingsSize*/)
{
	srand((long)system_time());
}

void
module_cleanup(void **outSettings, long *outSettingsSize)
{
	*outSettings = 0;
	*outSettingsSize = 0;
}

void
module_start_saving(BView *pView)
{	
	pView->Window()->Show();

	gpSaverThread = new KnotThread();
	gpSaverThread->StartSaving(pView);	
}

void
module_stop_saving(void)
{
	if (gpSaverThread) {
		gpSaverThread->StopSaving();
		delete gpSaverThread;
		gpSaverThread = 0;
	}
}

void
module_start_config(BView *pView)
{
	if (!pView->LockLooper()) {
		return;
	}
		
	BRect frame = pView->Bounds();
	frame.top += 10.0;
	frame.left += 10.0;
	font_height height;
	be_bold_font->GetHeight(&height);
	frame.bottom = frame.top+height.ascent+height.descent+height.leading;
	BStringView *pTitle =
		new BStringView(frame, B_EMPTY_STRING, "Samhain " SAMHAIN_VERSION);
	pTitle->SetViewColor(pView->ViewColor());
	pTitle->SetFont(be_bold_font);
	pView->AddChild(pTitle);
	
	frame = pView->Bounds();
	frame.top += 30.0;
	frame.bottom = frame.top + 44.0;
	frame.left += 20.0;
	frame.right -= 20.0;
	BRect textArea = frame;
	textArea.OffsetTo(B_ORIGIN);
	BTextView *pCaption =
		new BTextView(frame, B_EMPTY_STRING, textArea,
							B_FOLLOW_ALL, B_WILL_DRAW);
	pCaption->SetText("Celtic knotwork à la Andy Sloss.\n" 
							"© 1997–1999  Jens Kilian <jjk@acm.org>");
	pView->AddChild(pCaption);
	pCaption->SetViewColor(pView->ViewColor());
	pCaption->SetDrawingMode(B_OP_OVER);
	pCaption->SetFont(be_plain_font);
	pCaption->MakeEditable(FALSE);
	pCaption->MakeSelectable(FALSE);
	pCaption->SetWordWrap(TRUE);	
	
	BRect previewFrame = pView->Bounds();
	previewFrame.top = frame.bottom + 10.0;
	previewFrame.left += 10.0;
	previewFrame.right -= 10.0;
	previewFrame.bottom -= 10.0;
	BView *pPreview =
		new BView(previewFrame, B_EMPTY_STRING, B_FOLLOW_ALL, B_WILL_DRAW);
	pView->AddChild(pPreview);		
	pPreview->SetViewColor(0,0,0);
	pPreview->SetLowColor(0,0,0);
	pPreview->Invalidate();
	
	pView->Window()->UpdateIfNeeded();
	pView->UnlockLooper();
	
	gpConfigThread = new KnotThread();
	gpConfigThread->StartSaving(pPreview);
}

void
module_stop_config(void)
{
	if (gpConfigThread) {
		gpConfigThread->StopSaving();
		delete gpConfigThread;
		gpConfigThread = 0;
	}
}

static char RCSid[] = "$Id: Samhain.cpp,v 1.1 1999/01/10 09:54:36 jjk Exp $";
